#!/usr/bin/python

# HostBox SSH v0.3 - Release for the Linux platform.
#
# Released with GNU GENERAL PUBLIC LICENSE, http://www.gnu.org/licenses/gpl.html 
#
# Tool is written by Oskar Stridsman codefreakz78@gmail.com
#
# I got a new blog-adress!
#
# Visit http://stridsmaniancipher.wordpress.com
#

import sys
import wx
from HostBoxSSH import *



ID_NEW = 1
ID_RENAME = 2
ID_CLEAR = 3
ID_DELETE = 4
ID_OPN = 5
ID_USR = 6
ID_PSW = 7
ID_SCN = 8
ID_TIO = 9
ID_THR = 10



class RedirectText(object):
    def __init__(self,aWxTextCtrl):
        self.out=aWxTextCtrl
 
    def write(self,string):
        self.out.WriteText(string)

class HostBoxGUI(wx.Frame):
    def __init__(self, parent, id, title):
        wx.Frame.__init__(self, parent, id, title, size=(895, 657))
        
        self.usernames = ["admin","root","guest"]
        self.passwords = ["blank","password","-username"]
        self.timeout = 10
        self.threads = 25
        
        panel = wx.Panel(self, -1)
        hbox = wx.BoxSizer(wx.HORIZONTAL)
        self.listbox = wx.ListBox(panel, -1)
        log = wx.TextCtrl(panel, wx.ID_ANY, size=(300,300),style = wx.TE_MULTILINE|wx.TE_READONLY|wx.HSCROLL)

        
        hbox.Add(self.listbox, 1, wx.EXPAND | wx.ALL, 20)
        hbox.Add(log, 1, wx.ALL|wx.EXPAND, 20)
        
        btnPanel = wx.Panel(panel, -1)
        vbox = wx.BoxSizer(wx.VERTICAL)
        opn = wx.Button(btnPanel, ID_OPN, 'Import', size=(90, 30))
        new = wx.Button(btnPanel, ID_NEW, 'New', size=(90, 30))
        ren = wx.Button(btnPanel, ID_RENAME, 'Rename', size=(90, 30))
        dlt = wx.Button(btnPanel, ID_DELETE, 'Delete', size=(90, 30))
        clr = wx.Button(btnPanel, ID_CLEAR, 'Clear', size=(90, 30))
        settimeout = wx.Button(btnPanel, ID_TIO, 'timeout', size=(60, 20))
        setthreads = wx.Button(btnPanel, ID_THR, 'threads', size=(60, 20))
        setusr = wx.Button(btnPanel, ID_USR, 'Set Usernames', size=(120, 30))
        setpass = wx.Button(btnPanel, ID_PSW, 'Set Passwords', size=(120, 30))
        startscan = wx.Button(btnPanel, ID_SCN, 'Start Scan', size=(120, 30))
        self.skipacc = wx.CheckBox ( btnPanel,-1, 'skip on successful account login' )
        self.skipsrv = wx.CheckBox ( btnPanel,-1, 'skip on successful server login' )

        self.Bind(wx.EVT_BUTTON, self.OpenItem, id=ID_OPN)
        self.Bind(wx.EVT_BUTTON, self.NewItem, id=ID_NEW)
        self.Bind(wx.EVT_BUTTON, self.OnRename, id=ID_RENAME)
        self.Bind(wx.EVT_BUTTON, self.OnDelete, id=ID_DELETE)
        self.Bind(wx.EVT_BUTTON, self.OnClear, id=ID_CLEAR)
        self.Bind(wx.EVT_LISTBOX_DCLICK, self.OnRename)
        self.Bind(wx.EVT_BUTTON, self.Usr, id=ID_USR)
        self.Bind(wx.EVT_BUTTON, self.Psw, id=ID_PSW)
        self.Bind(wx.EVT_BUTTON, self.Scan, id=ID_SCN)
        self.Bind(wx.EVT_BUTTON, self.onTO, id=ID_TIO)
        self.Bind(wx.EVT_BUTTON, self.onTH, id=ID_THR)
        

        vbox.Add((-1, 20))
        vbox.Add(opn)
        vbox.Add(new)
        vbox.Add(ren, 0, wx.TOP, 5)
        vbox.Add(dlt, 0, wx.TOP, 5)
        vbox.Add(clr, 0, wx.TOP, 5)
        vbox.Add((-1, 20))
        vbox.Add(setusr, 0, wx.TOP, 5)
        vbox.Add(setpass, 0, wx.TOP, 5)
        vbox.Add((-1, 25))
        vbox.Add(settimeout, 0, wx.TOP, 5)
        vbox.Add(setthreads, 0, wx.TOP, 5)
        vbox.Add((-1, 55))
        vbox.Add(startscan, 0, wx.TOP, 5)
        vbox.Add((-1, 55))
        vbox.Add(self.skipacc, 0, wx.TOP, 5)
        vbox.Add(self.skipsrv, 0, wx.TOP, 5)

        btnPanel.SetSizer(vbox)
        hbox.Add(btnPanel, 0.6, wx.EXPAND | wx.RIGHT, 20)
        panel.SetSizer(hbox)
        
        redir=RedirectText(log)
        sys.stdout=redir

        self.Centre()
        self.Show(True)

    def NewItem(self, event):
        text = wx.GetTextFromUser('Enter a new host/ip..', 'Insert dialog')
        if text != '':
            self.listbox.Append(text)

    def OnRename(self, event):
        sel = self.listbox.GetSelection()
        text = self.listbox.GetString(sel)
        renamed = wx.GetTextFromUser('Rename host/ip', 'Rename dialog', text)
        if renamed != '':
            self.listbox.Delete(sel)
            self.listbox.Insert(renamed, sel)


    def OnDelete(self, event):
        sel = self.listbox.GetSelection()
        if sel != -1:
            self.listbox.Delete(sel)

    def OnClear(self, event):
        self.listbox.Clear()
        
    def OpenItem(self, event):
        filters = 'All files (*.*)|*.*'

        dialog = wx.FileDialog(self, message="Choose a iplist to import",defaultFile="",wildcard=filters,style=wx.OPEN | wx.MULTIPLE | wx.CHANGE_DIR)

        if dialog.ShowModal() == wx.ID_OK:
            selected = dialog.GetPath()
            dialog.Destroy()
            
            hostlines = getInfile(selected)
            for l in hostlines:
                j = l.rstrip()
                self.listbox.Append(j)
                
    def Usr(self, event):
        temp = ""
        
        for s in self.usernames:
            temp += s
            temp += ";"
        
        text = temp[0:-1]
        renamed = wx.GetTextFromUser('Rename item', 'Set usernames', text)
        if renamed != '':
            self.usernames = cleanPassList(renamed)
            
            
    def Psw(self, event):
        temp = ""
        
        for s in self.passwords:
            temp += s
            temp += ";"
        
        text = temp[0:-1]
        renamed = wx.GetTextFromUser('Rename item', 'Set passwords', text)
        if renamed != '':
            self.passwords = cleanPassList(renamed)
    
    def onTO(self, event):
        text = str(self.timeout)
        renamed = wx.GetTextFromUser('Set connection timeout', 'Set connection timeout', text)
        if renamed != '':
            self.timeout = renamed
            
        
        
    def onTH(self, event):
        text = str(self.threads)
        renamed = wx.GetTextFromUser('Set process threads', 'Set process threads', text)
        if renamed != '':
            self.threads = renamed
        
        
    def Scan(self, event):
        hosts = self.listbox.GetStrings()
        skipacc = False
        skipsrv = False
        breakoption = ""
        scantype = 0
        
        if self.skipacc.GetValue():
            skipacc = True
            
        if self.skipsrv.GetValue():
            skipsrv = True
            
        pathname = getLogPath()
        
        multiThreader(hosts,self.usernames,self.passwords,breakoption,pathname,int(self.threads),int(self.timeout))
    


app = wx.App()
HostBoxGUI(None, -1, 'HostBox SSH v0.3 - stridsmaniancipher.wordpress.com')
app.MainLoop()